namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "recycle")]
public class Recycle : Script, IScriptOnSecondaryEffect
{
    /// <inheritdoc />
    public void OnSecondaryEffect(IExecutingMove move, IPokemon target, byte hit)
    {
        if (move.User.HeldItem is not null)
        {
            move.GetHitData(target, hit).Fail();
            return;
        }
        var battleData = move.User.BattleData;
        if (battleData is null)
            return;
        var lastItem = battleData.BattleSide.GetLastConsumedItem(battleData.Position);
        if (lastItem is null)
        {
            move.GetHitData(target, hit).Fail();
            return;
        }
        _ = move.User.ForceSetHeldItem(lastItem);
    }
}